#include <math.h>
#include <string.h>
#include "erlang.h"
#include "queuel.h"
#include "mathlink.h"
#include "qlib.h"

/*
 * These functions merely serve as interface between
 * traffic library qlib.a written in C
 * and Mathematica
 */



/* local functions */
double D(double x) { return  x < 1 ? 0 : 1; }
double M(double x) { return  1.0 - exp(-x); }

void lnkMg1(int x, double rho)
{
    int     i=0;
    double *result;

    MLGetInteger(stdlink, &i);

    switch( i )
    {
        case 1:
            result = Mg1(x, rho, D);
            MLPutRealList(stdlink, result, x+1);
            break;
        case 2:
            result = Mg1(x, rho, M);
            MLPutRealList(stdlink, result, x+1);
        default:
            MLEvaluate(stdlink, "Message[LnkQmg1::usage]");
            break;
    }
}


void lnkSumMd1(int x, double rho)
{
    double *result;
  
    result = SumMd1(x, rho);
    MLPutRealList(stdlink, result, x+1);
}


void lnkRecMd1(int x, double rho)
{
    double *result;
  
    result = RecMd1(x, rho);
    MLPutRealList(stdlink, result, x+1);
}


void lnkMdn(double x, double rho, int n)
{
    double *result;
  
    result = Mdn(x, rho, n);
    MLPutRealList(stdlink, result, x+1);
}


double lnkbmitra(int j, int J, double C, int *d, long dl,
                 double *a, long al)
{
    if (al == dl && al == J)
        return Bmitra(j, J, C, d, a);
    else
        return 0;
}


double lnkbkaufman(int k, int K, int C, int *dk, long dl, double *ak, long al)
{
    if (al == dl && al == K)
        return Bkaufman(k, K, C, dk, ak);
    else
        return  0;
}

/*
 * Main loop, jump to Mathlink code
 */
int main(int argc, char **argv)
{
    return MLMain( argc, argv);
}
