#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "queuel.h"

/************************************************************

The Qlib program library has resulted from the work conducted
over several years jointly by

 Laboratory of Telecommunications Technology of
 Helsinki University of Technology (HUT) and

 VTT Information Technology, Telecommunications

The following individuals have contributed to the library:

 Samuli Aalto, Jani Lakkakorpi, Ilkka Norros, Anssi Pirhonen
 and Jorma Virtamo.

The programs can be used and modified freely.

No claims are made about the correctness of the programs
and no liability is taken for any damage caused by the use
of the programs in the library.

Reports of bugs in the program can be sent to qlib@tct.hut.fi

*************************************************************/

static double addlog(double, double);

double 
Qndd1(double x, int N, double D)
{
  double Q,C,logbin;
  int n;
  
  if (N >= D+x) return 1;
  if (x >= N) return 0;
  
  C = log(D-N+x)-N*log(D);
  Q = N*log((N-x)/D) - C;
  logbin = 0;
  
  for (n = N-1; n > x; n--) {
    logbin += log((double) (n+1)/ (N-n));
    Q = addlog(Q, logbin + n*log(n-x) + (N-n-1)*log(D-n+x));
  }
  return exp(Q+C);
}



static double addlog(double x, double y)
{
  double al,d;
  
  d = x - y;
  if (d >= 0)
    al = x;
  else {
    al = y;
    d = -d;
  }
  
  if (d > 700) 
    return al;
  
  d = exp(-d);
  
  if (d > 0.001)
    al += log(1.0 + d);
  else
    al += d*(1-d/2*(1-2*d/3));
  return al;
}









